<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve 3 question</p>
		<button onclick="reverse_each_k_node()">reverse every k node</button>
		<p id="demo"></p>

		<script>
			function reverse_each_k_node() {
                // User defined class node 
                class Node { 
                    // constructor 
                    constructor(element) 
                    { 
                        this.element = element; 
                        this.next = null
                    } 
                } 

                // linkedlist class 
                class LinkedList { 
                    constructor() { 
                        this.head = null; 
                        this.size = 0; 
                    }   

                    // adds an element at the end of list 
                    add(element) { 
                        // creates a new node 
                        var node = new Node(element); 
    
                        // to store current node 
                        var current; 
    
                        // if list is Empty add the element and make it head 
                        if (this.head == null) 
                            this.head = node; 
                        else {
                            current = this.head; 
    
                            // iterate to the end of the list 
                            while (current.next) { 
                                current = current.next; 
                            } 
                            // add node 
                            current.next = node;  
                            this.size++; 
                        }
                    }

                    // prints the list items 
                    printList() { 
                        var curr = this.head; 
                        var str = ""; 
                        while (curr) { 
                            str += curr.element + " "; 
                            curr = curr.next; 
                        } 
                        console.log(str); 
                    } 

                    skipMdeleteN(M, N) {
                        var curr = this.head;
                        var t;
                        //The main loop that traverses through the whole list 
                        while(curr) { 
                            //Skip M nodes 
                            for(var i=1; i< M; i++) {
                                if(curr==null) 
                                    return;
                                curr = curr.next
                            }
                            if(curr == null) 
                                return;
                            //Start from next node and delete N nodes 
                            t = curr.next 
                            for(var i=1; i< N+1; i++) { 
                                if(t == null) 
                                    break;
                                t = t.next
                            }
                            //Link the previous list with reamining nodes 
                            curr.next = t;
                            //Set Current pointer for next iteration 
                            curr = t;
                        }
                    }
                }

                // creating an object for the Linkedlist class 
                var ll = new LinkedList(); 

                // adding element to the list 
                ll.add(10);  
                ll.add(20); 
                ll.add(30); 
                ll.add(40); 
                ll.add(50); 
                ll.add(60);  
                ll.add(70); 
                ll.add(80); 
                ll.add(90); 
                ll.add(100);

                // print the list
                ll.printList();
                ll.skipMdeleteN(2,2);
                ll.printList();

        }

		</script>

	</body>
</html>